#!/usr/bin/python
from xml.dom import minidom
from cluster_functions import OptionError, cluPing
from ClusterEntity import *
import time

MY_INFO = {
   "WHOAMI"  : "cluster",

   "OPTIONS" : {
      "name"              : { "datatype" : "str",
                              "order"    : 0,
                              "default"  : "Red Hat Clumanager Cluster" },

      #"alias_ip"          : { "datatype" : "str",
      #                        "order"    : 1 },

      "config_viewnumber" : { "datatype" : "int",
                              "order"    : 2 },
   },

   "ADD_GETOPTS"     : [],

   "UPDATE_GETOPTS"  : [ "cluster",
                            "name=",
                            #"alias_ip=",
                            "config_viewnumber=" ],

   "DELETE_GETOPTS"  : [],
   "LISTALL_GETOPTS" : [],
} ### end MY_INFO

class cluster(ClusterEntity):
   def __init__(self, node, parent=None):

      ClusterEntity.__init__(self, MY_INFO, node, parent)

   ####################################################################
   # NOTE: In 'validate', WARNING errors must come *Last*, after all
   #       FATAL errors.  This is because the command line tool will
   #       override WARNING's in favor of doing the add or update,
   #       whereas the GUI will present the WARNING in a popup dialog.
   #       Since WARNINGs and ERROR's are 'raise'd, editing stops at
   #       that point.  So for the command line, we want to be sure
   #       that all FATAL checks have already been done, so that if a
   #       WARNING is raised, it can be safely overridden sinced we
   #       know that only WARNING checks remain.
   ####################################################################
   def validate(self, options):

      #######################################################################
      ########################   1. FATAL ERRORS   ##########################
      #######################################################################

      ### Check for *required* fields on "add" ###
      if self.action == "add":
         if not options.has_key("name"):
            raise OptionError("FATAL",
                              _("Cluster Name is required"),
                              "name",
                              None)

      #######################################################################
      ##########################   2. WARNINGS   ############################
      #######################################################################

      #if options.has_key("alias_ip") and \
      #   options["alias_ip"] != "" and \
      #   not cluPing(options["alias_ip"]):
      #      alias_ip = options["alias_ip"]
      #      raise OptionError("WARNING",
      #                        _("Cluster Alias IP Address not found on network"),
      #                        "alias_ip",
      #                        alias_ip)

   def updateViewnumber(self):
      current_viewnumber = self.get("config_viewnumber")
      if current_viewnumber == "": # will be null if option doesn't exist
                                   # in XML.
         new_viewnumber = 1
      else:
         new_viewnumber = current_viewnumber + 1

      ### Use 'cluster' classes 'set' method, since that converts
      ### the value to a string first - the xml options can only
      ### be set to string values.
      self.set("config_viewnumber", new_viewnumber)
