#!/usr/bin/python
from xml.dom import minidom
from clusterpkg.service_module import service
import clusterpkg.service_module
from ClusterList import *

SERVICE_INFO = clusterpkg.service_module.MY_INFO

MY_INFO = {
   "WHOAMI"  : "services",

   "OPTIONS" : { },

   "ADD_GETOPTS"     : [],
   "DELETE_GETOPTS"  : [],
   "UPDATE_GETOPTS"  : [],
   "LISTALL_GETOPTS" : [ "services" ],
}

class services(ClusterList):
   def __init__(self, node):
      parent = None
      ClusterList.__init__(self, MY_INFO, node, parent)

   def get_list(self):
      nodeList = []
      elements = self.node.getElementsByTagName("service")
      for e in elements:
         nodeList.append(service(e, self))
      return nodeList

   def get_service(self, val, key="name"):
      search_options = {key : val}
      service_entity = ClusterList.get_child(self, SERVICE_INFO, search_options)
      return service(service_entity.node, self)

   def service_found(self, search_options, service_being_validated):
      ### "service_being_validated" is either the service being modified, or
      ### the new service just added.  We want to be sure its key info doesn't
      ### duplicate an existing service.
      return ClusterList.child_found(self, SERVICE_INFO, search_options, service_being_validated)

   def add_service(self, cmdline_args=None):
      ### First, create a new "s"ervice entity
      entity = ClusterList.add_child(self, SERVICE_INFO)
      service_entity = service(entity.node, self, "add")
      service_entity.add_options(cmdline_args)

      ### Next, create new "service_ipaddresses" node - child of new "service"
      cluster_functions.append_dom_child(service_entity, "service_ipaddresses")
      return service_entity

   def delete_service(self, name, cmdline_args=None):
      search_options = {"name": name}
      ClusterList.delete_child(self, SERVICE_INFO, search_options, cmdline_args)

   def delete_service_by_id(self, id):
      ClusterList.delete_by_id(self, SERVICE_INFO, id)

   def out(self):
      nodeList = self.node.getElementsByTagName(SERVICE_INFO['WHOAMI'])
      for n in nodeList:
         service(n, self).out()
