#!/usr/bin/python

from clusterpkg.cluster_functions import getStatusOutput
import re
 
TRUE = 1
FALSE = 0
 
class cluDF:
    "Create a 'df' object with the specified directory or file"
    def __init__(self, path=""):
        if path == "":
            return None
        self.__path = path
        df_cmd = "/bin/df %s" % path
        (status, df_output) = getStatusOutput(df_cmd)
        lines_with_header = df_output.split('\n')
        lines = lines_with_header[1:]
        token_ct = 0
        line_tokens = []
        for line in lines:
            print "\nline: %s" % line
            tokens = re.split(r'\s+', line)
            for token in tokens:
                if token == "":
                    continue # For a filesystem that runs over 1 line -
                             # subsequent lines have null values in
                             # columns already presented on the previous
                             # line..
                token_ct = token_ct + 1
                line_tokens.append(token)

            if token_ct == 6: # processed all 6 tokens
                self.__filesystem   = line_tokens[0]
                self.__blocks       = line_tokens[1]
                self.__used         = line_tokens[2]
                self.__available    = line_tokens[3]
                self.__percent_used = line_tokens[4]
                self.__mountpoint   = line_tokens[5]
                line_tokens = []
                token_ct = 0

    def get_path(self):
        return self.__path
    def get_filesystem(self):
        return self.__filesystem
    def get_blocks(self):
        return self.__blocks
    def get_used(self):
        return self.__used
    def get_available(self):
        return self.__available
    def get_percent_used(self):
        return self.__percent_used
    def get_mountpoint(self):
        return self.__mountpoint
