#!/usr/bin/python

## deviceOrServiceIPAddressDialog.py

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import gtk
import gtk.glade
import gettext

##
## I18N
##

class deviceOrServiceIPAddressDialog: #(gtk.Dialog):
    def __init__(self, glade_xml):
        self.glade_xml = glade_xml

        self.dialog = glade_xml.get_widget('deviceOrServiceIPAddressDialog')

    def on_cancelbutton_clicked(self, button):
        pass

    def on_okbutton_clicked(self, button):

        ### "get" the new values from the Gui widgets ###
        device_radiobutton = self.glade_xml.get_widget('device_radiobutton')
        service_ipaddress_radiobutton = self.glade_xml.get_widget('service_ipaddress_radiobutton')

        self.__device_selected = device_radiobutton.get_active()
        self.__service_ipaddress_selected = service_ipaddress_radiobutton.get_active()

    def run(self):
        ### Connect the buttons to the functions ###
        self.ok     = self.glade_xml.get_widget('deviceOrServiceIPAddressDialog_okbutton').connect("clicked", self.on_okbutton_clicked)
        self.cancel = self.glade_xml.get_widget('deviceOrServiceIPAddressDialog_cancelbutton').connect("clicked", self.on_cancelbutton_clicked)

        rc = self.dialog.run()
        return rc

    def hide(self):
        self.glade_xml.get_widget('deviceOrServiceIPAddressDialog_okbutton').disconnect(self.ok)
        self.glade_xml.get_widget('deviceOrServiceIPAddressDialog_cancelbutton').disconnect(self.cancel)
        return self.dialog.hide()

    def get_device_selected(self):
        return self.__device_selected

    def get_service_ipaddress_selected(self):
        return self.__service_ipaddress_selected
