import sys

import gtk
import gtk.glade
import signal
import os
import gettext
import gobject

import failoverdomainnodeDialog

##
## I18N
## 

_=gettext.gettext

COLUMN_NAME = 0
COLUMN_DATA = 1

class failoverdomainnodesListview:
    def __init__(self, glade_xml):
        #print "failoverdomainnodesListview __init__ TOP:"
        self.glade_xml = glade_xml
        self.tree_view = self.glade_xml.get_widget ('failoverdomainnodesTreeview')
        ### This is a 'List', so use 'ListStore' (not TreeStore) ###
        self.model = gtk.ListStore(gobject.TYPE_STRING,
                                   gobject.TYPE_PYOBJECT)
        self.tree_view.set_model(self.model)
        self.tree_view.set_reorderable(gtk.TRUE)

        column = gtk.TreeViewColumn(_("Node"),
                                    gtk.CellRendererText(),
                                    text=COLUMN_NAME)
        self.tree_view.append_column(column)

        self.tree_view.get_selection().select_path ((0,))
        self.dialog = failoverdomainnodeDialog.failoverdomainnodeDialog(self.glade_xml)

    def set_failoverdomain(self, failoverdomain_entity):
        self.failoverdomain_entity = failoverdomain_entity

    def get_nodes_in_domain(self):
	node_list = []
        def foreach_func (model, path, iter, text):
            node_entity = model.get_value (iter, COLUMN_DATA)
            node_list.append(node_entity)
        self.model.foreach (foreach_func, None)
        return node_list

    def set_nodes_in_domain(self, failoverdomain_entity, node_list):
        self.model.clear()
        for n in node_list:
            failoverdomainnode_item = failoverdomainnodeDialog.failoverdomainnodeItem(self, n)
            iter=self.model.append()
            self.model.set(iter,
                           COLUMN_NAME, n.get("name"),
                           COLUMN_DATA, failoverdomainnode_item)

    def add(self):
        node_item = failoverdomainnodeDialog.failoverdomainnodeItem(self, None)
        new_node_items_list = node_item.add()
        if len(new_node_items_list) != 0:
            for new_node_item in new_node_items_list:
                iter = self.model.append()
                self.model.set(iter,
                               COLUMN_NAME, new_node_item.get("name"),
                               COLUMN_DATA, new_node_item)

    def delete(self):
        result = self.tree_view.get_selection().get_selected ()
        if result == None:
            return 
        (model, iter) = result
        if iter == None:
            return
        item = model.get_value(iter, COLUMN_DATA)
        message=_("Are you sure you want to remove '%s'?") % item.get_value_of_key_field()
        dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO,
                                gtk.BUTTONS_YES_NO,
                                message)
        dlg.set_position(gtk.WIN_POS_MOUSE)
        dlg.show_all()
        rc = dlg.run()
        dlg.destroy()
        if rc==gtk.RESPONSE_YES:
            ### remove "iter" from Gui ###
            model.remove(iter)

            ### remove "item" from DOM XML ###
            item.delete()
